/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Aiccログ形式不正時のログ出力クラス
//			変更履歴
//				2004.01.08	新規作成	二條智文
//
package jp.co.ntt.lms.lo.WBT.Aicc;

import java.util.*;
import java.io.*;
import java.text.*;
import jp.co.ntt.lms.xmo.Environment;

/**
 * Aiccログ形式不正時のログ出力クラス。<BR>
 * @author T.Nijou
 * @version 0.0.0.1 2004/01/08
 */
public class AiccLogErr {

	/** AiccLog不正エラー時のログファイル名 */
	private static final String LOG_FILE = "AiccErr";

	/**
	 * Aiccログ形式不正時のログ出力
	 * @param strMsg ログ出力内容
	 */
	synchronized static public void write( String strMsg ) {
		write( null, null, null, strMsg );
	}

	/**
	 * Aiccログ形式不正時のログ出力
	 * @param strUserID ユーザID
	 * @param strLoID LOID
	 * @param strSessionID セッションID
	 * @param strMsg ログ出力内容
	 */
	synchronized static public void write(	String strUserID,
											String strLoID,
											String strSessionID,
											String strMsg)
	{
		try {
			// 環境設定ファイル読み込みクラスをインスタンス化
			Environment objEnv = new Environment();

			String strDirPath = objEnv.getLogPath();

			// 現在の日付を取得してファイル名を決定します
			SimpleDateFormat objFormat = new SimpleDateFormat( "yyyyMMdd" );
			Date objToday = new Date();
			String strToday = objFormat.format( objToday );
			String strFileName = LOG_FILE + strToday + ".log";


			String strFilePath = "";
			strFilePath = strDirPath + "/" + strFileName;
			File objFile = new File(strDirPath);
			if(objFile.exists() == false)
			{
				objFile.mkdirs();
			}
			objFile = new File(strFilePath);
			if (objFile.exists() == false)
			{
				objFile.createNewFile();
			}

			//  ファイルストリームオブジェクトの作成
			FileOutputStream objDebugStream = new FileOutputStream(strFilePath, true);
			OutputStreamWriter objOutputWriter = null;
			
			String lsCsvEncode = objEnv.getCsvEncode();
			objOutputWriter = new OutputStreamWriter(objDebugStream,lsCsvEncode);
			PrintWriter objPrint = new PrintWriter(objOutputWriter);

			objFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
			Date objNow = new Date();
			String strDate = objFormat.format(objNow);								//現在時刻取得

			//	情報を出力
			objPrint.print("------ " + strDate + " -------------------------------------------------------------------------------");
			objPrint.print("\n");
			objPrint.print( "エラー:: " + strMsg );
			objPrint.print("\n");
			if( strUserID != null ) {
				objPrint.print( "ユーザ:: " + strUserID );
				objPrint.print("\n");
			}
			if( strLoID != null ) {
				objPrint.print( "LO:: " + strLoID );
				objPrint.print("\n");
			}
			if( strSessionID != null ) {
				objPrint.print( "回数:: " + strSessionID );
				objPrint.println( "\n" );
			}
			objPrint.println("\n");

			objPrint.close();

			try {
				objOutputWriter.close();
				objDebugStream.close();				
			}
			catch( IOException Ex ) {
				//  エラーは無視
			}
		}
		catch( FileNotFoundException Ex ) {
			Ex.printStackTrace();
			//  ここでエラーが発生した場合は、対処方法がないので無視する
		}
		catch( Exception Ex) {
			Ex.printStackTrace();
		}
	}

}